#!/usr/bin/perl

#
# Captcha Mail : captmail.cgi - 2013/02/08
# copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[s
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib './lib';
use CGI::Minimal;
use Jcode;
require './lib/base64.pl';

# Jcode錾
my $j = new Jcode;

# ݒt@CF
require "./init.cgi";
my %cf = &init;

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&error('eʃI[o[') if ($cgi->truncated);
my ($key,$need,$in) = &parse_form;

# tH[\L
&load_form if (@$key == 0);

# ֎~[h`FbN
if ($cf{no_wd}) {
	my $flg;
	foreach (@$key) {
		foreach my $wd ( split(/,/, $cf{no_wd}) ) {
			if (index($$in{$_},$wd) >= 0) {
				$flg++;
				last;
			}
		}
		if ($flg) { &error("֎~[h܂܂Ă܂"); }
	}
}

# zXg擾`FbN
my ($host,$addr) = &get_host;

# K{̓`FbN
my ($check,@err);
if ($$in{need} || @$need > 0) {

	# needtB[h̒lK{zɉ
	my @tmp = split(/\s+/, $$in{need});
	push(@$need,@tmp);

	# K{z̏dvfr
	my (@uniq,%seen);
	foreach (@$need) {
		push(@uniq,$_) unless $seen{$_}++;
	}

	# K{ڂ̓͒l`FbN
	foreach (@uniq) {

		# tB[h̒lĂȂ́iWI{^j
		if (!defined($$in{$_})) {
			$check++;
			push(@$key,$_);
			push(@err,$_);

		# ͂Ȃ̏ꍇ
		} elsif ($$in{$_} eq "") {
			$check++;
			push(@err,$_);
		}
	}
}

# ͓e}b`
my ($match1, $match2);
if ($$in{match}) {
	($match1, $match2) = split(/\s+/, $$in{match}, 2);

	if ($$in{$match1} ne $$in{$match2}) {
		&error("$match1$match2̍ē͓eقȂ܂");
	}
}

# ̓`FbNmF
if ($check) {
	&err_check($match2);
}

# --- vr[
if ($$in{mode} ne "send" && $cf{preview}) {

	# AM`FbN
	&check_post('view');

	# mF
	&preview;

# --- Ms
} else {

	# AM`FbN
	&check_post('send');

	# sendmailM
	&send_mail;
}

#-----------------------------------------------------------
#  tH[\
#-----------------------------------------------------------
sub load_form {
	# 摜F؍쐬
	require $cf{captcha_pl};
	my ($str_plain,$str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );

	# evǂݍ
	open(IN,"$cf{tmpldir}/form2.html") or &error("open err: form2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ϊ
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;

	# tH[\L
	print "Content-type: text/html; charset=shift_jis\n\n";
	print &footer($tmpl);
	exit;
}

#-----------------------------------------------------------
#  vr[
#-----------------------------------------------------------
sub preview {
	# postM`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		&error("sȃANZXł");
	}

	# Me`FbN
	&error("f[^擾ł܂") if (@$key == 0);

	# [`FbN
	&check_email($$in{email}) if ($$in{email});

	# 摜F؃`FbN
	require $cf{captcha_pl};
	if ($$in{captcha} !~ /^\d{$cf{cap_len}}$/) {
		&error("摜F؂͕słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
	}

	# eL[`FbN
	# -1 : L[sv
	#  0 : ԃI[o[
	#  1 : L[v
	my $chk = cap::check($$in{captcha},$$in{str_crypt},$cf{captcha_key},$cf{cap_time},$cf{cap_len});
	if ($chk == 0) {
		&error("摜F؂Ԃ𒴉߂܂B<br>etH[ɖ߂čēǍ݌Aw̐ē͂Ă");
	} elsif ($chk == -1) {
		&error("摜F؂słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
	}

	# Ԏ擾
	my $time = time;

	# ꎞt@C쐬
	my $rand = &make_tmp($time);

	# ev[gǍ
	open(IN,"$cf{tmpldir}/conf2.html") or &error("open err: conf2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- cell_begin -->(.+)<!-- cell_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gs");

	# 
	my $hidden =<<EOM;
<input type="hidden" name="mode" value="send" />
<input type="hidden" name="tmp_data" value="$rand" />
EOM

	# 
	my ($bef, $item);
	foreach my $key (@$key) {
		next if ($bef eq $key);
		next if ($key eq "x");
		next if ($key eq "y");
		next if ($key eq "captcha");
		next if ($key eq "str_crypt");
		if ($key eq "need" || $key eq "match" || ($$in{match} && $key eq $match2)) {
			next;
		}

		# namel`FbN
		check_key($key) if ($cf{check_key});
		my $val = b64_encode($$in{$key});
		$hidden .= qq|<input type="hidden" name="$key" value="$val" />\n|;

		# sϊ
		$$in{$key} =~ s/\t/<br \/>/g;

		my $tmp = $loop;
		if (defined($cf{replace}->{$key})) {
			$tmp =~ s/!key!/$cf{replace}->{$key}/;
		} else {
			$tmp =~ s/!key!/$key/;
		}
		$tmp =~ s/!val!/$$in{$key}/;
		$item .= $tmp;

		$bef = $key;
	}

	# u
	for ( $head, $foot ) {
		s/!mail_cgi!/$cf{mail_cgi}/g;
		s/<!-- hidden -->/$hidden/g;
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head, $item;

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  Ms
#-----------------------------------------------------------
sub send_mail {
	# postM`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		&error("sȃANZXł");
	}

	# Me`FbN
	&error("f[^擾ł܂") if (@$key == 0);

	# ꎞt@C`FbN
	&check_tmp;

	# [`FbN
	&check_email($$in{email},'send') if ($$in{email});

	# Ԏ擾
	my ($date1,$date2) = &get_time;

	# uEU
	my $agent = $ENV{HTTP_USER_AGENT};
	$agent =~ s/[<>&"'()+;]//g;

	# {evǂݍ
	my $tbody;
	open(IN,"$cf{tmpldir}/mail.txt") or &error("open err: mail.txt");
	my $tbody = join('', <IN>);
	close(IN);

	# s
	$tbody =~ s/\r\n/\n/g;
	$tbody =~ s/\r/\n/g;

	# evϐϊ
	$tbody =~ s/!date!/$date1/g;
	$tbody =~ s/!agent!/$agent/g;
	$tbody =~ s/!host!/$host/g;
	$tbody = $j->set(\$tbody,'sjis')->jis;

	# ԐM̂Ƃ
	my $resbody;
	if ($cf{auto_res}) {

		# ev
		open(IN,"$cf{tmpldir}/reply.txt") or &error("open err: reply.txt");
		$resbody = join('', <IN>);
		close(IN);

		# s
		$resbody =~ s/\r\n/\n/g;
		$resbody =~ s/\r/\n/g;

		# ϐϊ
		$resbody =~ s/!date!/$date1/g;
		$resbody = $j->set(\$resbody,'sjis')->jis;
	}

	# {̃L[WJ
	my ($bef,$mbody,$log);
	foreach (@$key) {

		# {Ɋ܂߂Ȃr
		next if ($_ eq "mode");
		next if ($_ eq "need");
		next if ($_ eq "match");
		next if ($$in{match} && $_ eq $match2);
		next if ($_ eq 'tmp_data');
		next if ($bef eq $_);

		# B64fR[h
		$$in{$_} = b64_decode($$in{$_});

		# namel̖O
		my $key_name;
		if ($cf{replace}->{$_}) {
			$key_name = $cf{replace}->{$_};
		} else {
			$key_name = $_;
		}

		# GXP[v
		$$in{$_} =~ s/\.\n/\. \n/g;

		# Ytt@C̕񋑔
		$$in{$_} =~ s/Content-Disposition:\s*attachment;.*//ig;
		$$in{$_} =~ s/Content-Transfer-Encoding:.*//ig;
		$$in{$_} =~ s/Content-Type:\s*multipart\/mixed;\s*boundary=.*//ig;

		# s
		$$in{$_} =~ s/\t/\n/g;

		# HTML^Oϊ
		$$in{$_} =~ s/&lt;/</g;
		$$in{$_} =~ s/&gt;/>/g;
		$$in{$_} =~ s/&quot;/"/g;
		$$in{$_} =~ s/&#39;/'/g;
		$$in{$_} =~ s/&amp;/&/g;

		# {e
		my $tmp;
		if ($$in{$_} =~ /\n/) {
			$tmp = "$key_name = \n$$in{$_}\n";
		} else {
			$tmp = "$key_name = $$in{$_}\n";
		}
		$mbody .= $tmp;

		$bef = $_;
	}
	# R[hϊ
	$mbody = $j->set(\$mbody,'sjis')->jis;

	# {ev̕ϐu
	$tbody =~ s/!message!/$mbody/;

	# ԐMev̕ϐu
	$resbody =~ s/!message!/$mbody/ if ($cf{auto_res});

	# [AhXȂꍇ͑Mɒu
	my $email;
	if ($$in{email} eq "") {
		$email = $cf{mailto};
	} else {
		$email = $$in{email};
	}

	# MIMEGR[h
	my $sub_me = $j->set($cf{subject},'sjis')->mime_encode;
	my $from;
	if ($$in{name}) {
		$$in{name} =~ s/[\r\n]//g;
		$from = $j->set("\"$$in{name}\" <$email>",'sjis')->mime_encode;
	} else {
		$from = $email;
	}

	# --- MetH[}bgJn
	# wb_[
	my $body = "To: $cf{mailto}\n";
	$body .= "From: $from\n";
	$body .= "Subject: $sub_me\n";
	$body .= "MIME-Version: 1.0\n";
	$body .= "Content-type: text/plain; charset=iso-2022-jp\n";
	$body .= "Content-Transfer-Encoding: 7bit\n";
	$body .= "Date: $date2\n";
	$body .= "X-Mailer: $cf{version}\n\n";
	$body .= "$tbody\n";

	# ԐMetH[}bg
	my $res_body;
	if ($cf{auto_res}) {

		# MIMEGR[h
		my $re_sub = $j->set($cf{sub_reply},'sjis')->mime_encode;

		$res_body .= "To: $email\n";
		$res_body .= "From: $cf{mailto}\n";
		$res_body .= "Subject: $re_sub\n";
		$res_body .= "MIME-Version: 1.0\n";
		$res_body .= "Content-type: text/plain; charset=iso-2022-jp\n";
		$res_body .= "Content-Transfer-Encoding: 7bit\n";
		$res_body .= "Date: $date2\n";
		$res_body .= "X-Mailer: $cf{version}\n\n";
		$res_body .= "$resbody\n";
	}

	# senmdailR}h
	my $scmd = $cf{send_fcmd} ? "$cf{sendmail} -t -i -f $email" : "$cf{sendmail} -t -i";

	# {M
	open(MAIL,"| $scmd") or &error("[Ms");
	print MAIL "$body\n";
	close(MAIL);

	# ԐMM
	if ($cf{auto_res}) {
		my $scmd = $cf{send_fcmd} ? "$cf{sendmail} -t -i -f $cf{mailto}" : "$cf{sendmail} -t -i";

		open(MAIL,"| $scmd") or &error("[Ms");
		print MAIL "$res_body\n";
		close(MAIL);
	}

	# [h
	if ($cf{reload}) {
		if ($ENV{PERLXS} eq "PerlIS") {
			print "HTTP/1.0 302 Temporary Redirection\r\n";
			print "Content-type: text/html\n";
		}
		print "Location: $cf{back}\n\n";
		exit;

	# bZ[W
	} else {
		open(IN,"$cf{tmpldir}/thx.html") or &error("open err: thx.html");
		my $tmpl = join('', <IN>);
		close(IN);

		# \
		print "Content-type: text/html; charset=shift_jis\n\n";
		$tmpl =~ s/!back!/$cf{back}/g;
		&footer($tmpl);
	}
}

#-----------------------------------------------------------
#  ̓G[\
#-----------------------------------------------------------
sub err_check {
	my $match2 = shift;

	# ev[gǂݍ
	my ($err, $flg, $cell, %fname, %err);
	open(IN,"$cf{tmpldir}/err2.html") or &error("open err: err2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- cell_begin -->(.+)<!-- cell_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gs");

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;
	my $bef;
	foreach my $key (@$key) {
		next if ($key eq "need");
		next if ($key eq "match");
		next if ($key eq "captcha");
		next if ($key eq "str_crypt");
		next if ($$in{match} && $key eq $match2);
		next if ($key eq "match");
		next if ($bef eq $key);
		next if ($key eq "x");
		next if ($key eq "y");

		my $key_name = $key;
		my $tmp = $loop;
		if(defined($cf{replace}->{$key})) {
			$key_name = $cf{replace}->{$key};
		}
		$tmp =~ s/!key!/$key_name/;

		my $erflg;
		foreach my $err (@err) {
			if ($err eq $key) {
				$erflg++;
				last;
			}
		}
		# ͂Ȃ
		if ($erflg) {
			$tmp =~ s/!val!/<span class="msg">$key_name͓͕K{ł.<\/span>/;

		# 
		} else {
			$$in{$key} =~ s/\t/<br \/>/g;
			#$$in{$key} =~ s/\0/ /g;
			$tmp =~ s/!val!/$$in{$key}/;
		}
		print $tmp;

		$bef = $key;
	}
	print $foot;
	exit;
}

#-----------------------------------------------------------
#  tH[fR[h
#-----------------------------------------------------------
sub parse_form {
	my (@key,@need,%in);
	foreach my $key ( $cgi->param() ) {

		# l̏ꍇ̓Xy[Xŋ؂
		my $val = join(" ", $cgi->param($key));

		# Q/sϊ
		$key =~ s/[<>&"'\r\n]//g;
		$val =~ s/&/&amp;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&#39;/g;
		$val =~ s/\r\n/\t/g;
		$val =~ s/\r/\t/g;
		$val =~ s/\n/\t/g;

		# R[hϊ
		if ($cf{conv_code}) {
			$key = $j->set($key)->sjis;
			$val = $j->set($val)->sjis;
		}

		# ͕K{
		if ($key =~ /^_(.+)/) {
			$key = $1;
			push(@need,$key);
		}

		# 󂯎L[̏ԂoĂ
		push(@key,$key);

		# %innbVɑ
		$in{$key} = $val;
	}

	# t@XŕԂ
	return (\@key, \@need, \%in);
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/err1.html") or &error("open err: err1.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!error!/$err/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time);
	my @week  = qw|Sun Mon Tue Wed Thu Fri Sat|;
	my @month = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;

	# ̃tH[}bg
	my $date1 = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min,$sec);
	my $date2 = sprintf("%s, %02d %s %04d %02d:%02d:%02d",
			$week[$wday],$mday,$month[$mon],$year+1900,$hour,$min,$sec) . " +0900";

	return ($date1,$date2);
}

#-----------------------------------------------------------
#  zXg擾
#-----------------------------------------------------------
sub get_host {
	# zXg擾
	my $h = $ENV{REMOTE_HOST};
	my $a = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($h eq "" || $h eq $a)) {
		$h = gethostbyaddr(pack("C4", split(/\./, $a)), 2);
	}
	if ($h eq "") { $h = $a; }

	# `FbN
	if ($cf{denyhost}) {
		my $flg;
		foreach ( split(/\s+/, $cf{denyhost}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($h =~ /$_/i) { $flg++; last; }
		}
		if ($flg) { &error("ANZXĂ܂"); }
	}

	return ($h, $a);
}

#-----------------------------------------------------------
#  M`FbN
#-----------------------------------------------------------
sub check_post {
	my $job = shift;

	# Ԏ擾
	my $now = time;

	# OI[v
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $data = <DAT>;

	# 
	my ($ip, $time) = split(/<>/, $data);

	# IPyюԂ`FbN
	if ($ip eq $addr && $now - $time <= $cf{block_post}) {
		close(DAT);
		&error("AM$cf{block_post}bԂ҂");
	}

	# M͕ۑ
	if ($job eq "send") {
		seek(DAT, 0, 0);
		print DAT "$addr<>$now";
		truncate(DAT, tell(DAT));
	}
	close(DAT);
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="text-align:center;font-size:10px;font-family:Verdana,Helvetica,Arial;margin-top:3em;">
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ꎞt@C쐬
#-----------------------------------------------------------
sub make_tmp {
	my $time = shift;

	# 
	my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z');

	# 
	my $rand;
	srand;
	for (1 .. 20) {
		$rand .= $wd[int(rand(@wd))];
	}

	# ꎞfBNgɏ
	open(TMP,"+> $cf{tmpdir}/$rand.dat") or &error("write err: $rand.dat");
	print TMP $time;
	close(TMP);

	return $rand;
}

#-----------------------------------------------------------
#  ꎞt@C`FbN
#-----------------------------------------------------------
sub check_tmp {
	# f[^
	if ($$in{tmp_data} !~ /^[0-9a-zA-Z]{20}$/ || !-e "$cf{tmpdir}/$$in{tmp_data}.dat") {
		&error("sȃANZXł!");
	}

	# ԃ`FbN
	open(IN,"$cf{tmpdir}/$$in{tmp_data}.dat") or &error("open err: $$in{tmp_data}.dat");
	my $data = <IN>;
	close(IN);

	if (time - $data > 60*60) {
		&error("Ԓ߂̂ߏ𒆒f܂");
	}

	# ꎞt@C폜
	unlink("$cf{tmpdir}/$$in{tmp_data}.dat");

	# S~|
	my $time = time;
	opendir(DIR,"$cf{tmpdir}");
	while( $_ = readdir(DIR) ) {
		next if (!/^\w+\.dat$/);

		# 60ȏo߂͍폜
		my $mtime = (stat("$cf{tmpdir}/$_"))[9];
		if ($time - $mtime > 3600) {
			unlink("$cf{tmpdir}/$_");
		}
	}
	closedir(DIR);
}

#-----------------------------------------------------------
#  Base64GR[h
#-----------------------------------------------------------
sub b64_encode {
	my $data = shift;

	my $str = base64::b64encode($data);
	$str =~ s/\n/\t/g;
	return $str;
}

#-----------------------------------------------------------
#  Base64fR[h
#-----------------------------------------------------------
sub b64_decode {
	my $str = shift;

	$str =~ s/\t/\n/g;
	return base64::b64decode($str);
}

#-----------------------------------------------------------
#  dq[`FbN
#-----------------------------------------------------------
sub check_email {
	my ($eml,$job) = @_;

	# MB64fR[h
	if ($job eq 'send') { $eml = b64_decode($eml); }

	# E-mail`FbN
	if ($eml =~ /\,/) {
		&error("[AhXɃR} ( , ) ܂܂Ă܂");
	}
	if ($eml ne '' && $eml !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		&error("[AhX̏sł");
	}
}

#-----------------------------------------------------------
#  namel`FbN
#-----------------------------------------------------------
sub check_key {
	my $key = shift;

	if ($key !~ /^(?:[0-9a-zA-Z_-]|[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC])+$/) {
		error("namelɕsȕ܂܂Ă܂");
	}
}

